/*
 * Copyright ©Rastislav Mirek. All rights reserved.
 * No waranty for this software or derived works.
 */

package cz.muni.fi.pb162.graphicalobjectexample.graphicalobjects;

import java.awt.Color;


/**
 * This class represents AbstractGraphicalObject.
 *
 * Created 28.10.2009 at 13:30:45.
 *
 * @author Rastislav Mirek <rmirek at mail.muni.cz>
 * @version %I%, %G%
 * @since 1.0
 */
public abstract class AbstractGraphicalObject implements GraphicalObject{

    private Color color;

    private static int abstractGraphicalObjectsInstancesCount = 0;

    public AbstractGraphicalObject(Color color) {
        if(color == null){
            throw new NullPointerException("coordinate");
        }

        this.color = color;
        abstractGraphicalObjectsInstancesCount++;
    }

    public AbstractGraphicalObject(int red, int green, int blue){
        color = new Color(red, green, blue);
        abstractGraphicalObjectsInstancesCount++;
    }

    public static int getAbstractGraphicalObjectsInstancesCount() {
        return abstractGraphicalObjectsInstancesCount;
    }

    public abstract boolean contains(Coordinate point);

    public void moveAbsolutely(Coordinate toPosition){
        if(toPosition.equals(getPosition())){
            return;
        }
        moveRelatively(getPosition().getX() - toPosition.getX(),
                getPosition().getY() - toPosition.getY());
    }

    public Color getColor() {
        return color;
    }

    public abstract Coordinate getPosition();

    public abstract Coordinate moveRelatively(int relX, int relY);

    @Override
    public String toString() {
        return "Graphical object with color that can be drawn on the screen.";
    }
}
