/*
 * Copyright ©Rastislav Mirek. All rights reserved.
 * No waranty for this software or derived works.
 */

package cz.muni.fi.pb162.graphicalobjectexample.graphicalobjects;

import java.awt.Color;

/**
 * This class represents Rectangle that has lines aligned to x and y coordinates.
 *
 * Created 29.10.2009 at 3:18:56.
 *
 * @author Rastislav Mirek <rmirek at mail.muni.cz>
 * @version %I%, %G%
 * @since 1.0
 */
public class Rectangle extends Tetragon{

    private int height;
    private int width;

    public Rectangle(Coordinate a, int width, int hight, Color color) {
        super(a, new Coordinate(a.getX() + width, a.getY()),
                new Coordinate(a.getX() + width, a.getY() + hight),
                new Coordinate(a.getX(), a.getY() + hight), color);
        this.height = hight;
        this.width = width;
    }

    @Override
    public boolean isConcave() {
        return true;
    }

    @Override
    public double getArea() {
        return width * height;
    }

    @Override
    public boolean contains(Coordinate point) {
        return point.getX() >= getA().getX() 
                && point.getY() >= getA().getY()
                && point.getX() <= getA().getX() + width
                && point.getY() <= getA().getY() + height;
    }

    public int getWidth() {
        return width;
    }

    public int getHeight() {
        return height;
    }

    @Override
    public String toString() {
        return super.toString() + " This polygon is rectangle with width: " + getWidth()
                + " and hight: " + getHeight() + ".";
    }

}
